Skip to main content
POST
/
exchange
Vault transfer
curl --request POST \
  --url https://api.hyperliquid.xyz/exchange \
  --header 'Content-Type: application/json' \
  --data '
{
  "action": {
    "type": "vaultTransfer",
    "vaultAddress": "0x1234567890abcdef1234567890abcdef12345678",
    "isDeposit": true,
    "usd": 1000000
  },
  "nonce": 1705234567890,
  "signature": {
    "r": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "s": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "v": 27
  },
  "vaultAddress": null
}
'
import requests

url = "https://api.hyperliquid.xyz/exchange"

payload = {
"action": {
"type": "vaultTransfer",
"vaultAddress": "0x1234567890abcdef1234567890abcdef12345678",
"isDeposit": True,
"usd": 1000000
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'vaultTransfer',
vaultAddress: '0x1234567890abcdef1234567890abcdef12345678',
isDeposit: true,
usd: 1000000
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};

fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "status": "<string>",
  "response": {}
}
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Deposits into or withdraws from a Hyperliquid vault.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.

Parameters

Required parameters

  • action (object, required) — The action object containing:
    • type (string) — Must be "vaultTransfer"
    • vaultAddress (string) — Vault address
    • isDeposit (boolean) — True to deposit, false to withdraw
    • usd (integer) — Amount in raw USD units
  • nonce (number, required) — Current timestamp in milliseconds (must be recent)
  • signature (object, required) — EIP-712 signature of the action

Optional parameters

  • vaultAddress (string, optional) — Address when trading on behalf of a vault or subaccount

Returns

Returns an object with the action status:
  • status"ok" if request processed
  • response — Contains action result data

Example request

curl -X POST https://api.hyperliquid.xyz/exchange \
  -H "Content-Type: application/json" \
  -d '{
    "action": {"type": "vaultTransfer"},
    "nonce": 1234567890123,
    "signature": {...}
  }'
from eth_account import Account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants

# Load the wallet that signs the action
wallet = Account.from_key("0xYOUR_PRIVATE_KEY")

# Public Hyperliquid mainnet API
exchange = Exchange(wallet, constants.MAINNET_API_URL)

# Deposit into the vault. usd is the amount in raw USD units (float * 1e6),
# so 10 USDC is 10 * 1_000_000. Set is_deposit=False to withdraw.
result = exchange.vault_usd_transfer(
    vault_address="0x1719884eb866cb12b2287399b15f7db5e7d775ea",
    is_deposit=True,
    usd=10 * 1_000_000,
)
print(result)
import * as hl from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";

// Wallet that signs the action
const wallet = privateKeyToAccount("0xYOUR_PRIVATE_KEY");

// Public Hyperliquid mainnet API (default transport)
const transport = new hl.HttpTransport();
const client = new hl.ExchangeClient({ transport, wallet });

// Deposit into the vault. usd is the amount in raw USD units (float * 1e6),
// so 10 USDC is 10 * 1e6. Set isDeposit: false to withdraw.
const result = await client.vaultTransfer({
  vaultAddress: "0x1719884eb866cb12b2287399b15f7db5e7d775ea",
  isDeposit: true,
  usd: 10 * 1e6,
});
console.log(result);

Use case

  • Vault transfer — Deposits into or withdraws from a Hyperliquid vault.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.

Body

application/json
action
object
required
nonce
integer
required

Current timestamp in milliseconds

signature
object
required

EIP-712 signature of the action with r, s, v components

vaultAddress
string | null

Address when trading on behalf of a vault or subaccount (optional)

Response

200 - application/json

Action result

status
string

Request status

response
object

Action response data

Last modified on July 7, 2026